import '../base/types.dart';
import '../base/parser.dart';
import 'RegexLexer.dart';

abstract class LibraryLexer extends RegexLexer<JParse> {
  RegexLexer? _next;
  String? _root;
  void loadNext(RegexLexer? next) {
    _next = next;
  }

  void loadRoot(String? root) {
    _root = root;
  }

  String get symbolInSys => '$hashCode';

  @override
  RegExpFlags get flags =>
      _next?.flags ??
      RegExpFlags(
        dotAll: true,
        multiline: true,
      );

  @override
  Map<String, List<JParse>> get parses => _next != null
      ? {
          symbolInSys: [
            JParse.lexer(_next!, doActionsWithoutState: [CLEAR, _next!.root])
          ]
        }
      : {};

  @override
  String get root => _next != null ? symbolInSys : _root ?? 'root';
}
